package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.GotoInstruction;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.VariableLengthInstruction;
import org.apache.bcel.generic.Visitor;

public class GOTO extends GotoInstruction implements VariableLengthInstruction {
  GOTO() {}
  
  public GOTO(InstructionHandle target) {
    super((short)167, target);
  }
  
  public void accept(Visitor v) {
    v.visitVariableLengthInstruction(this);
    v.visitUnconditionalBranch(this);
    v.visitBranchInstruction(this);
    v.visitGotoInstruction(this);
    v.visitGOTO(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    setIndex(getTargetOffset());
    short opcode = getOpcode();
    if (opcode == 167) {
      super.dump(out);
    } else {
      setIndex(getTargetOffset());
      out.writeByte(opcode);
      out.writeInt(getIndex());
    } 
  }
  
  protected int updatePosition(int offset, int maxOffset) {
    int i = getTargetOffset();
    setPosition(getPosition() + offset);
    if (Math.abs(i) >= 32767 - maxOffset) {
      setOpcode((short)200);
      short oldLength = (short)getLength();
      setLength(5);
      return getLength() - oldLength;
    } 
    return 0;
  }
}
